/**
 * Copyright (c) 2015-2017 Obeo, Inria
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 	
 * Contributors:
 * - William Piers <william.piers@obeo.fr>
 * - Philippe Merle <philippe.merle@inria.fr>
 * - Faiez Zalila <faiez.zalila@inria.fr>
 */
package workflow.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import workflow.util.WorkflowAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class WorkflowItemProviderAdapterFactory extends WorkflowAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkflowItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Task} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TaskItemProvider taskItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Task}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTaskAdapter() {
		if (taskItemProvider == null) {
			taskItemProvider = new TaskItemProvider(this);
		}

		return taskItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Executionlink} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExecutionlinkItemProvider executionlinkItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Executionlink}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExecutionlinkAdapter() {
		if (executionlinkItemProvider == null) {
			executionlinkItemProvider = new ExecutionlinkItemProvider(this);
		}

		return executionlinkItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Datalink} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DatalinkItemProvider datalinkItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Datalink}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDatalinkAdapter() {
		if (datalinkItemProvider == null) {
			datalinkItemProvider = new DatalinkItemProvider(this);
		}

		return datalinkItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Controlflowlink} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ControlflowlinkItemProvider controlflowlinkItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Controlflowlink}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createControlflowlinkAdapter() {
		if (controlflowlinkItemProvider == null) {
			controlflowlinkItemProvider = new ControlflowlinkItemProvider(this);
		}

		return controlflowlinkItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Taskdependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TaskdependencyItemProvider taskdependencyItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Taskdependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTaskdependencyAdapter() {
		if (taskdependencyItemProvider == null) {
			taskdependencyItemProvider = new TaskdependencyItemProvider(this);
		}

		return taskdependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Platformdependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PlatformdependencyItemProvider platformdependencyItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Platformdependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPlatformdependencyAdapter() {
		if (platformdependencyItemProvider == null) {
			platformdependencyItemProvider = new PlatformdependencyItemProvider(this);
		}

		return platformdependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Decision} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DecisionItemProvider decisionItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Decision}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDecisionAdapter() {
		if (decisionItemProvider == null) {
			decisionItemProvider = new DecisionItemProvider(this);
		}

		return decisionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Storagecanal} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StoragecanalItemProvider storagecanalItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Storagecanal}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStoragecanalAdapter() {
		if (storagecanalItemProvider == null) {
			storagecanalItemProvider = new StoragecanalItemProvider(this);
		}

		return storagecanalItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Networkcanal} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NetworkcanalItemProvider networkcanalItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Networkcanal}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNetworkcanalAdapter() {
		if (networkcanalItemProvider == null) {
			networkcanalItemProvider = new NetworkcanalItemProvider(this);
		}

		return networkcanalItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Remotedatacanal} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RemotedatacanalItemProvider remotedatacanalItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Remotedatacanal}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRemotedatacanalAdapter() {
		if (remotedatacanalItemProvider == null) {
			remotedatacanalItemProvider = new RemotedatacanalItemProvider(this);
		}

		return remotedatacanalItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Profile} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProfileItemProvider profileItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Profile}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProfileAdapter() {
		if (profileItemProvider == null) {
			profileItemProvider = new ProfileItemProvider(this);
		}

		return profileItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Localcanal} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LocalcanalItemProvider localcanalItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Localcanal}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLocalcanalAdapter() {
		if (localcanalItemProvider == null) {
			localcanalItemProvider = new LocalcanalItemProvider(this);
		}

		return localcanalItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Taskobservation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TaskobservationItemProvider taskobservationItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Taskobservation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTaskobservationAdapter() {
		if (taskobservationItemProvider == null) {
			taskobservationItemProvider = new TaskobservationItemProvider(this);
		}

		return taskobservationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Controlflowguard} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ControlflowguardItemProvider controlflowguardItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Controlflowguard}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createControlflowguardAdapter() {
		if (controlflowguardItemProvider == null) {
			controlflowguardItemProvider = new ControlflowguardItemProvider(this);
		}

		return controlflowguardItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Loop} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopItemProvider loopItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Loop}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLoopAdapter() {
		if (loopItemProvider == null) {
			loopItemProvider = new LoopItemProvider(this);
		}

		return loopItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Nesteddependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NesteddependencyItemProvider nesteddependencyItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Nesteddependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNesteddependencyAdapter() {
		if (nesteddependencyItemProvider == null) {
			nesteddependencyItemProvider = new NesteddependencyItemProvider(this);
		}

		return nesteddependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Loopiteration} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopiterationItemProvider loopiterationItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Loopiteration}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLoopiterationAdapter() {
		if (loopiterationItemProvider == null) {
			loopiterationItemProvider = new LoopiterationItemProvider(this);
		}

		return loopiterationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Foreach} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ForeachItemProvider foreachItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Foreach}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createForeachAdapter() {
		if (foreachItemProvider == null) {
			foreachItemProvider = new ForeachItemProvider(this);
		}

		return foreachItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.For} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ForItemProvider forItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.For}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createForAdapter() {
		if (forItemProvider == null) {
			forItemProvider = new ForItemProvider(this);
		}

		return forItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.While} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WhileItemProvider whileItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.While}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createWhileAdapter() {
		if (whileItemProvider == null) {
			whileItemProvider = new WhileItemProvider(this);
		}

		return whileItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Parallelloop} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParallelloopItemProvider parallelloopItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Parallelloop}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createParallelloopAdapter() {
		if (parallelloopItemProvider == null) {
			parallelloopItemProvider = new ParallelloopItemProvider(this);
		}

		return parallelloopItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Replica} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReplicaItemProvider replicaItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Replica}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReplicaAdapter() {
		if (replicaItemProvider == null) {
			replicaItemProvider = new ReplicaItemProvider(this);
		}

		return replicaItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link workflow.Shared} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SharedItemProvider sharedItemProvider;

	/**
	 * This creates an adapter for a {@link workflow.Shared}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSharedAdapter() {
		if (sharedItemProvider == null) {
			sharedItemProvider = new SharedItemProvider(this);
		}

		return sharedItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (taskItemProvider != null) taskItemProvider.dispose();
		if (executionlinkItemProvider != null) executionlinkItemProvider.dispose();
		if (datalinkItemProvider != null) datalinkItemProvider.dispose();
		if (controlflowlinkItemProvider != null) controlflowlinkItemProvider.dispose();
		if (taskdependencyItemProvider != null) taskdependencyItemProvider.dispose();
		if (platformdependencyItemProvider != null) platformdependencyItemProvider.dispose();
		if (decisionItemProvider != null) decisionItemProvider.dispose();
		if (loopItemProvider != null) loopItemProvider.dispose();
		if (nesteddependencyItemProvider != null) nesteddependencyItemProvider.dispose();
		if (storagecanalItemProvider != null) storagecanalItemProvider.dispose();
		if (networkcanalItemProvider != null) networkcanalItemProvider.dispose();
		if (remotedatacanalItemProvider != null) remotedatacanalItemProvider.dispose();
		if (profileItemProvider != null) profileItemProvider.dispose();
		if (localcanalItemProvider != null) localcanalItemProvider.dispose();
		if (taskobservationItemProvider != null) taskobservationItemProvider.dispose();
		if (controlflowguardItemProvider != null) controlflowguardItemProvider.dispose();
		if (loopiterationItemProvider != null) loopiterationItemProvider.dispose();
		if (foreachItemProvider != null) foreachItemProvider.dispose();
		if (forItemProvider != null) forItemProvider.dispose();
		if (whileItemProvider != null) whileItemProvider.dispose();
		if (parallelloopItemProvider != null) parallelloopItemProvider.dispose();
		if (replicaItemProvider != null) replicaItemProvider.dispose();
		if (sharedItemProvider != null) sharedItemProvider.dispose();
	}

}
